<?php

	defined('_JEXEC') or die('Restricted access');
	define( JPATH_COMPONENT, 'hikashop' );

	class plgHikashopBrainstyles extends JPlugin 
	{
		public $user;

		function plgHikashopBrainstyles( &$subject, $config )
		{
			parent::__construct( $subject, $config );
			$this->user = JFactory::getUser();
			$this->user->demographics = JUserHelper::getProfile( $this->user->id );

			if( !isset( $this->params ) )
			{
				$plugin = JPluginHelper::getPlugin( 'hikashop', 'brainstyles' );
				$this->params = new JRegistry( $plugin->params );
			}
		}



		function onAfterUserCreate( &$element )
		{
			$id = ( $element->user_cms_id )? $element->user_cms_id: $element->order_user_id;
			$app = JFactory::getApplication();
			$data = $app->input->get( 'data', array(), 'array' );

			if( !empty( $data['address'] ) )
			{
				$address = $data['address'];
				$db = JFactory::getDBO();

				/*-------- Demographics --------*/
				$query = "REPLACE INTO `#__user_profiles` SET 
					`user_id` = " . $id . ",
					`profile_key` = 'demographics.firstname',
					`profile_value` = " . $db->quote( $address['address_firstname'] ) . ",
					`ordering` = 1";

				$db->setQuery( $query );
				$j = $db->execute();


				$query = "REPLACE INTO `#__user_profiles` SET 
					`user_id` = " . $id . ",
					`profile_key` = 'demographics.lastname',
					`profile_value` = " . $db->quote( $address['address_lastname'] ) . ",
					`ordering` = 2";

				$db->setQuery( $query );
				$j = $db->execute();


				$query = "REPLACE INTO `#__user_profiles` SET 
					`user_id` = " . $id . ",
					`profile_key` = 'demographics.address1',
					`profile_value` = " . $db->quote( $address['address_street'] ) . ",
					`ordering` = 4";

				$db->setQuery( $query );
				$j = $db->execute();


				$query = "REPLACE INTO `#__user_profiles` SET 
					`user_id` = " . $id . ",
					`profile_key` = 'demographics.city',
					`profile_value` = " . $db->quote( $address['address_city'] ) . ",
					`ordering` = 6";

				$db->setQuery( $query );
				$j = $db->execute();


				switch( $address['address_state'] )
				{
					case 'state_Alabama_4261': $state = 'Alabama'; break;
					default: $state = 'Texas'; break;
				}

				$query = "REPLACE INTO `#__user_profiles` SET 
					`user_id` = " . $id . ",
					`profile_key` = 'demographics.state',
					`profile_value` = " . $db->quote( $state ) . ",
					`ordering` = 7";

				$db->setQuery( $query );
				$j = $db->execute();


				switch( $address['address_country'] )
				{
					case 'country_United_States_of_America_223': $country = 'USA'; break;
					default: $country = NULL; break;
				}

				$query = "REPLACE INTO `#__user_profiles` SET 
					`user_id` = " . $id . ",
					`profile_key` = 'demographics.country',
					`profile_value` = " . $db->quote( $country ) . ",
					`ordering` = 8";

				$db->setQuery( $query );
				$j = $db->execute();


				$query = "REPLACE INTO `#__user_profiles` SET 
					`user_id` = " . $id . ",
					`profile_key` = 'demographics.postalcode',
					`profile_value` = " . $db->quote( $address['address_post_code'] ) . ",
					`ordering` = 9";

				$db->setQuery( $query );
				$j = $db->execute();


				$query = "REPLACE INTO `#__user_profiles` SET 
					`user_id` = " . $id . ",
					`profile_key` = 'demographics.phone',
					`profile_value` = " . $db->quote( $address['address_telephone'] ) . ",
					`ordering` = 10";

				$db->setQuery( $query );
				$j = $db->execute();


				$query = "REPLACE INTO `#__user_profiles` SET 
					`user_id` = " . $id . ",
					`profile_key` = 'demographics.company',
					`profile_value` = '',
					`ordering` = 23";

				$db->setQuery( $query );
				$j = $db->execute();


				$query = "REPLACE INTO `#__user_profiles` SET 
					`user_id` = " . $id . ",
					`profile_key` = 'demographics.gender',
					`profile_value` = '',
					`ordering` = 11";

				$db->setQuery( $query );
				$j = $db->execute();


				$query = "REPLACE INTO `#__user_profiles` SET 
					`user_id` = " . $id . ",
					`profile_key` = 'demographics.race',
					`profile_value` = '',
					`ordering` = 12";

				$db->setQuery( $query );
				$j = $db->execute();


				$query = "REPLACE INTO `#__user_profiles` SET 
					`user_id` = " . $id . ",
					`profile_key` = 'demographics.agerange',
					`profile_value` = '',
					`ordering` = 13";

				$db->setQuery( $query );
				$j = $db->execute();


				$query = "REPLACE INTO `#__user_profiles` SET 
					`user_id` = " . $id . ",
					`profile_key` = 'demographics.matrimony',
					`profile_value` = '',
					`ordering` = 15";

				$db->setQuery( $query );
				$j = $db->execute();


				$query = "REPLACE INTO `#__user_profiles` SET 
					`user_id` = " . $id . ",
					`profile_key` = 'demographics.education',
					`profile_value` = '',
					`ordering` = 17";

				$db->setQuery( $query );
				$j = $db->execute();


				/*-------- Assign to Groups --------*/
				$query = "REPLACE INTO `#__user_usergroup_map` SET 
					`user_id` = " . $id . ",
					`group_id` = 2";

				$db->setQuery( $query );
				$j = $db->execute();


				$query = "REPLACE INTO `#__user_usergroup_map` SET 
					`user_id` = " . $id . ",
					`group_id` = 10";

				$db->setQuery( $query );
				$j = $db->execute();
			}

			return true;
		}



		function onAfterOrderCreate( &$order, &$send_email )
		{
			foreach( $order->cart->products as $product )
			{
				$inv = array( 'INV20' => 0 );
				switch( $product->product_id )
				{
					case 5: // Test Product
					case 13: // Test Product
						$inv['INV20'] = $inv['INV20'] + $product->order_product_quantity;
						break;
				}
			}

			if( $inv['INV20'] )
				$this->buildReservation( 'INV', '2.0', $inv['INV20'], $order );
		}



		function buildReservation( $type, $vers, $qty, &$order )
		{
			$db = JFactory::getDBO();
			$billing = $order->cart->billing_address;
			$created = new datetime();
			$created->setTimestamp( $order->order_created );
			$pid = 0;

			if( !empty( $order->coach ) )
			{
				$purchase = new stdClass();
				$purchase->id        = NULL;
				$purchase->coach_id  = $this->getCoachId( $this->user->get('id') );
				$purchase->lname     = $billing->address_lastname;
				$purchase->fname     = $billing->address_firstname;
				$purchase->email     = $this->user->get('email');	
				$purchase->order_id  = $order->order_id;
				$purchase->serial    = $order->order_number;
				$purchase->status    = 'pending';
				$purchase->type      = $type;
				$purchase->version   = $vers;
				$purchase->label     = $order->label;
				$purchase->purchased = $qty;
				$purchase->reserved  = 0;
				$purchase->created   = $created->format( "Y-m-d H:i:s" );
				$purchase->updated   = $created->format( "Y-m-d H:i:s" );

				/*-------- Assign to Purchases --------*/
				$query = $db->getQuery(true)
					->insert( '#__bs_purchases' )
					->set( '`id` = ' . $db->quote( $purchase->id ) )
					->set( '`coach_id` = ' . $db->quote( $purchase->coach_id ) )
					->set( '`lname` = ' . $db->quote( $purchase->lname ) )
					->set( '`fname` = ' . $db->quote( $purchase->fname ) )
					->set( '`email` = ' . $db->quote( $purchase->email ) )
					->set( '`order_id` = ' . $db->quote( $purchase->order_id ) )
					->set( '`serial` = ' . $db->quote( $purchase->serial ) )
					->set( '`status` = ' . $db->quote( $purchase->status ) )
					->set( '`type` = ' . $db->quote( $type ) )
					->set( '`version` = ' . $db->quote( $vers ) )
					->set( '`label` = ' . $db->quote( $purchase->label ) )
					->set( '`purchased` = ' . $db->quote( $purchase->purchased ) )
					->set( '`reserved` = ' . $db->quote( $purchase->reserved ) )
					->set( '`created` = ' . $db->quote( $purchase->created ) )
					->set( '`updated` = ' . $db->quote( $purchase->updated ) );

				$db->setQuery( $query );

				if( $db->execute() )
					JFactory::getApplication()->enqueueMessage( 'Brainstyles Purchase record(s) created.', 'message' );
			}else
			{
				$pcodes = array();

				for( $q = $qty; $q > 0; $q-- )
				{
					$codetest = true;

					while( $codetest )
					{
						$pcode = substr( hash( "md5", rand( 100000, 999999 ) ), 0, 8 );

						$query2 = $db->getQuery(true)
							->select( '`passcode`' )
							->from( '#__bs_reservations' )
							->where( '`passcode` = ' . $db->quote( $pcode ) );

						$db->setQuery( $query2 );
						$db->execute();

						$codetest = $db->numRows();
					}

					$resrvtn = new stdClass();
					$resrvtn->id          = NULL;
					$resrvtn->user_id     = $this->user->get('id');
					$resrvtn->coach_id    = 0;	
					$resrvtn->purchase_id = 0;
					$resrvtn->passcode    = $pcode;
					$resrvtn->firstname   = $billing->address_firstname;
					$resrvtn->lastname    = $billing->address_lastname;
					$resrvtn->email       = $this->user->get('email');
					$resrvtn->serial      = $order->order_number;
					$resrvtn->version     = $type . $vers;
					$resrvtn->label       = '';
					$resrvtn->status      = 'pending';
					$resrvtn->created     = $created->format( "Y-m-d H:i:s" );

					/*-------- Assign to Purchases --------*/
					$query3 = $db->getQuery(true)
						->insert( '#__bs_reservations' )
						->set( '`id` = ' . $db->quote( $resrvtn->id ) )
						->set( '`user_id` = ' . $db->quote( $resrvtn->user_id ) )
						->set( '`coach_id` = ' . $db->quote( $resrvtn->coach_id ) )
						->set( '`purchase_id` = ' . $db->quote( $resrvtn->purchase_id ) )
						->set( '`passcode` = ' . $db->quote( $resrvtn->passcode ) )
						->set( '`firstname` = ' . $db->quote( $resrvtn->firstname ) )
						->set( '`lastname` = ' . $db->quote( $resrvtn->lastname ) )
						->set( '`email` = ' . $db->quote( $resrvtn->email ) )
						->set( '`serial` = ' . $db->quote( $resrvtn->serial ) )
						->set( '`version` = ' . $db->quote( $resrvtn->version ) )
						->set( '`label` = ' . $db->quote( $resrvtn->label ) )
						->set( '`status` = ' . $db->quote( $resrvtn->status ) )
						->set( '`created` = ' . $db->quote( $resrvtn->created ) );

					$db->setQuery( $query3 );

					if( $db->execute() )
						$pcodes[ $resrvtn->version ][] = $resrvtn->passcode;
				}

				if( count( $pcodes ) )
				{
					JFactory::getApplication()->enqueueMessage( 'Brainstyles Reservation record(s) created.', 'message' );
					$order->order_passcodes = $pcodes;
				}
			}
		}




		function getCoachId( $id = null )
		{
			$db = JFactory::getDBO();
			$query = $db->getQuery( true )
				->select( 'id' )
				->from( '#__contact_details' )
				->where( '`user_id` = ' . $id );
			$db->setQuery( $query );
			$db->execute();
			$item = $db->loadObject();

			return $item->id;
		}




		function onAfterOrderUpdate( &$order, &$send_email )
		{
			$db = JFactory::getDBO();

			if( $order->history->history_type == 'payment' )
			{
				$query = $db->getQuery(true)
					->update( '#__bs_reservations' )
					->where( '`serial` = ' . $db->quote( $order->order_number ) )
					->set( "`status` = 'ready'" );
				$db->setQuery( $query );
				$db->execute();

				$query = $db->getQuery(true)
					->update( '#__bs_purchases' )
					->where( '`serial` = ' . $db->quote( $order->order_number ) )
					->set( "`status` = 'active'" );
				$db->setQuery( $query );
				$db->execute();
			}
		}
	}
